//	Ex1.c
//	This is the simplest embedded code example: turning a single output on
//	and off through use of a page.

static int StdPageHead(char * p, const char * pszTitle)
{	return sprintf(p,
		"<html>"
		"<head>"
		"<title>%s</title>"
		"</head>"
		"<body><h1>%s</h1>",
		pszTitle, pszTitle);
}

static char szEx1On[] = "<p><a href=\"ex1on\">Turn microwave emitter on</a></p>";
static char szEx1Off[] = "<p><a href=\"ex1off\">Turn microwave emitter off</a></p>";

static bool bCacheOn, bCacheOff;	//	cheat to simulate a cache hit
static bool SimulateCache(struct EscWebRequest * pReq, bool * pb)
{	if (*pb)
	{	int i;
		for (i=0; pReq->m_pszHeader[i]; i++)
			if (_strnicmp(pReq->m_pszHeader+i, "Cache-Control", 13) == 0)
				return false;
		return true;
	}
	*pb = true;
	return false;
}

void PageEx1(SOCKET nSock, struct EscWebRequest * pReq)
{	char * p = pReq->m_pBuff;
	p += StdPageHead(p, "Microwave Control");
	p += sprintf(p, "%s%s</body></html>", szEx1On, szEx1Off);
	HttpHtmlResponse(nSock, pReq, p);
	bCacheOn = bCacheOff = false;	//	reset the caching simulation
}

void PageEx1on(SOCKET nSock, struct EscWebRequest * pReq)
{	char * p = pReq->m_pBuff;
	p += StdPageHead(p, "Microwave Control");
	if (!SimulateCache(pReq, &bCacheOn))
		EscPower(true);
	p += sprintf(p, "<p>The microwave emitter is now <strong>ON</strong>.</p>"
		"%s</body></html>", szEx1Off);
	HttpHtmlResponse(nSock, pReq, p);
}

void PageEx1off(SOCKET nSock, struct EscWebRequest * pReq)
{	char * p = pReq->m_pBuff;
	p += StdPageHead(p, "Microwave Control");
	if (!SimulateCache(pReq, &bCacheOff))
		EscPower(false);
	p += sprintf(p, "<p>The microwave emitter is now <em>off</em>.</p>"
		"%s</body></html>", szEx1On);
	HttpHtmlResponse(nSock, pReq, p);
}
