//	EscWeb.h

#include "usnet/socket.h"
#include "usnet/net.h"

#define HTTP_PORT_NUMBER 80
typedef int SOCKET;
#define INVALID_SOCKET  (SOCKET)(~0)
#define SOCKET_ERROR            (-1)
#define HTTP_BUFF_SIZE			1024
#define HTTP_HEADER_SIZE		512
#define HTTP_SEND_BUFF_SIZE		32768

struct EscWebRequest
{	char * m_pBuff;
	const char * m_pszPath;
	const char * m_pszParams;
	const char * m_pszHeader;
	const char * m_pszPost;
	int m_nMajorVers;
	int m_nMinorVers;
	bool m_bKeepAlive;
	bool m_bSendBody;
};

struct EscWebPageHandler
{	const char * m_pszPath;
	void (* m_pfn)(SOCKET, struct EscWebRequest *);
};

struct EscWebResource
{	const char * m_pszPath;
	void * m_pData;
	int m_cbData;		//	actual length, or 0 for word size prefix,
						//	or -1 for strlen
	const char * m_pszHeader;
};

void SendTcp(SOCKET nSock, const char * pBuff, int cbBuff);
void HttpResponse(SOCKET nSock, int nRetCode, const char * pszRetMsg,
	const char * pszHeader, const char * pBody, int cbBody, bool bSendBody,
	bool bKeepAlive);
void HttpError(SOCKET nSock, int nRetCode, const char * pszRetMsg);
void HttpHtmlResponse(SOCKET nSock, struct EscWebRequest * pReq, const char
	* pEnd);

int _stricmp(const char * psz1, const char * psz2);
int _strnicmp(const char * psz1, const char * psz2, int len);

void EscPower(bool bOn);
void EscLamp(bool bOn);
void EscStartRun(BYTE nMin, BYTE nSec, BYTE nPower);
void EscStopRun(void);
void EscAjaxString(char * pBuff);
extern bool gbEscPower;
extern bool gbEscLamp;
extern BYTE gnEscTimerMin, gnEscTimerSec, gnEscPower;
extern bool gbEscRun;

extern struct EscWebPageHandler tblWebPageHandler[];
extern struct EscWebResource tblWebResource[];
extern char szOK[];
extern char szTextHtml[];
extern char szTextPlain[];
